const {ProxyTyper, AsyncFunction} = require("proxy-typer")
class Test {
        constructor(value, number) {
            this.value = value;
            this.number = number;
        }

        setValue(val) {
            this.number = val;
            return this.number;
        }

        async getValue() {
            return this.number.toString();
        }
    }

    Test.propTypes = {
        value: String, // is same like {type: String}
        number: Number, // if prop isn't required then {type: Number, required: false}
        setValue: {type: Function, args: [{type: Number}]}, // if function need to return value then add {return: [Type]}
        getValue: {type: AsyncFunction, return: String}
    };

    const TestModel = ProxyTyper(Test);
    const test = new TestModel("test", 45);
    test.setValue(3);
    test.getValue();;
